

#include "iostream"
#include "cassert"
#include "vector"
#include "cmath"

#define check(x) cerr << (#x) << " = " << x << "\n"

using namespace std;

#define int long long

int solve();

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    assert(cin >> t);
    while (t--) solve();
    return 0;
}

vector<int> divs, p;

int solve() {
    int a, b, k, m;
    assert(cin >> a >> b >> k >> m);

    if (m > a * b) {
        cout << "-1\n";
        return 0;
    }

    if (k > a - 1 + b - 1) {
        cout << "-1\n";
        return 0;
    }

    if (a == 1) {
        if (k != m - 1) {
            cout << "-1\n";
        } else {
            cout << "0 " << m - 1 << "\n";
        }
        return 0;
    } else if (k <= (int) 1e5 ){
        for (int h = 0; h < min(k + 1, a); ++h) {
            int v = (m / (h + 1)) - 1;
            if (m % (h + 1) == 0 && 0 <= v && v < b && h + v == k) {
                cout << h << " " << v << "\n";
                return 0;
            }
        }
    } else {
        divs.clear();

        p.reserve(1000);

        int mm = m;

        for (int d = 1; d * d <= m; ++d) {
            if (m % d == 0) divs.push_back(d);
            while (mm % d == 0) mm /= d;
        }

//        check(mm);

        p.clear();

        if (mm > 1) {
            if (mm == (int) sqrt(mm) * (int) sqrt(mm)) {
                p.push_back(sqrt(mm));
                p.push_back(sqrt(mm));
            } else {
                for (int d = 2; d * d <= mm; ++d) {
                    if (mm % d == 0) {
                        p.push_back(d);
                        p.push_back(mm / d);
                        break;
                    }
                }

                if (p.empty()) p.push_back(mm);
            }

            if ((int) p.size() == 2) {
                p.push_back(p[0] * p[1]);
            }
        }

        p.push_back(1);

        for (int i = 0; i < (int) divs.size(); ++i) {
            for (int j = 0; j < (int) p.size(); ++j) {
                int x = divs[i] * p[j];

                if (m % x == 0) {
                    int y = m / x;

                    y--;
                    x--;

                    if (0 <= x && x < a && 0 <= y && y < b) {
                        if (x + y == k) {
                            cout << x << " " << y << "\n";
                            return 0;
                        }
                    } else if (0 <= x && x < b && 0 <= y && y < a) {
                        if (x + y == k) {
                            cout << y << " " << x << "\n";
                            return 0;
                        }
                    }
                }
            }
        }
    }
    cout << "-1\n";
    return 0;
}