#include "iostream"
#include "cassert"

using namespace std;

#define int long long

int solve();

signed main() {
    int t;
    assert(cin >> t);
    while (t--) solve();
    return 0;
}

int solve() {
    int a, b, k, m;
    assert(cin >> a >> b >> k >> m);

    if (m > a * b) {
        cout << "-1\n";
        return 0;
    }

    if (k > a - 1 + b - 1) {
        cout << "-1\n";
        return 0;
    }

    if (a == 1) {
        if (k != m - 1) {
            cout << "-1\n";
        } else {
            cout << "0 " << m - 1 << "\n";
        }
        return 0;
    } else {
        for (int h = 0; h < min(k + 1, a); ++h) {
            int v = (m / (h + 1)) - 1;
            if (m % (h + 1) == 0 && 0 <= v && v < b && h + v == k) {
                cout << h << " " << v << "\n";
                return 0;
            }
        }
    }
    cout << "-1\n";
    return 0;
}