#include "iostream"
#include "cassert"
#include "vector"
#include "cmath"

#define check(x) cerr << (#x) << " = " << x << "\n"

using namespace std;

#define int long long

int solve();

signed main() {
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);
    int t;
    assert(cin >> t);
    while (t--) solve();
    return 0;
}

vector<int> divs;

int solve() {
    int a, b, k, m;
    assert(cin >> a >> b >> k >> m);

    if (m > a * b) {
        cout << "-1\n";
        return 0;
    }

    if (k > a - 1 + b - 1) {
        cout << "-1\n";
        return 0;
    }

    if (a == 1) {
        if (k != m - 1) {
            cout << "-1\n";
        } else {
            cout << "0 " << m - 1 << "\n";
        }
        return 0;
    } else {
        divs.clear();
        divs.push_back(1);
        divs.push_back(m);
        for (int d = 2; d * d <= m; ++d) {
            if (m % d == 0) {
                if (m / d != d) divs.push_back(m / d);
                divs.push_back(d);
            }
        }
        for (int i = 0; i < (int) divs.size(); ++i) {
            int x = divs[i];
            int y = m / x;

            if (x + y - 2 == k) {
                x--;
                y--;
                if (0 <= x && x < a && 0 <= y && y < b) {
                    cout << x << " " << y << "\n";
                    return 0;
                }
            }
        }
    }
    cout << "-1\n";
    return 0;
}