#pragma GCC optimize("Ofast")

#include "iostream"
#include "cassert"
#include "vector"
#include "cmath"
#include "unordered_map"
#include "map"
#include "ext/pb_ds/assoc_container.hpp"

const int N = (int)2e6 + 117;
const int MAX = (int) 1e6;

const int MEM = 2.5e8;

char mem[MEM];

int mpos = 0;

void* operator new(size_t n) {
    char* cur = mem + n;
    mpos += n;
    assert(mpos <= MEM);
    return (void*) cur;
}

void operator delete(void*) {}

#define check(x) cerr << (#x) << " = " << x << "\n"

using namespace std;
using namespace __gnu_pbds;

//#define int long long

int solve();

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    assert(cin >> t);
    while (t--) solve();
    return 0;
}

//unordered_map<int, int> t[N];

cc_hash_table<int, int> t[N];

int x = 0, y = 0;
int k, n;

cc_hash_table<char, pair<int, int>> mode;

void paint(char c) {
    for (int i = x + mode[c].first; i < x + k; ++i) {
        for (int j = y + mode[c].second; j < y + k; ++j) {
            t[i + MAX][j] = 1;
        }
    }
}

int solve() {
    assert(cin >> k >> n);

    mode['E'] = { k - 1, 0};
    mode['W'] = { 0, 0};
    mode['N'] = { 0, k - 1 };
    mode['S'] = { 0, 0 };

    for (int i = x; i < k; ++i) {
        for (int j = y; j < k; ++j) {
//            t[{i, j}] = 1;
            t[i + MAX][j] = 1;
        }
    }

    while (n--) {
        char c;
        int a;
        assert(cin >> c >> a);

        for (int i = 0; i < a; ++i) {
//            cout << t.size() << "\n";
            if (c == 'E') x++;
            else if (c == 'N') y++;
            else if (c == 'W') x--;
            else if (c == 'S') y--;
            paint(c);
        }
    }

//    cout << t.size() << "\n";

    int ans = 0;

    for (int i = 0; i < N; ++i) ans += (int)t[i].size();

    cout << ans << "\n";


    return 0;
}
