#include <iostream>
#include "cassert"

using namespace std;

using ll = long long;

const ll INFll = (ll) 1e12 + 117;
const int N = (int)101;

int n;
ll p;

ll a[N], b[N], z[N];

inline bool f(ll x) {
    __int128 res = 0;
    for (int i = 0; i < n; ++i) {
        res += (__int128)a[i] * min(x, z[i]) + max((__int128)0, (__int128)b[i] * (x - z[i]));
    }
    return res >= p;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    assert(cin >> n >> p);

    for (int i = 0; i < n; ++i) assert(cin >> z[i] >> a[i] >> b[i]);

    ll l = 0, r = INFll;

    while (r - l > 1) {
        ll m = (l + r) >> 1;

        if (f(m)) r = m;
        else l = m;
    }

    cout << r << "\n";
    return 0;
}
